
source('~/Revision Code/Revision2/simple_rrr.R')

##run simulation for predictive performance with independent ridge regressions

library(doParallel)
library(foreach)
cl <- makeCluster(8)
registerDoParallel(cl)
q1 = 5
q2 = 10
p1 = 15
p2 = 20
nvec = c(30,120)
s2nvec = c(1,5)
lambdaVec = c(0,0.5,1,5,50)
Seeds = array(30*c(1:(10*2*2*5)),dim=c(30,2,2,5))
#####first, for X correlation
for(i in 1:30){
#  library(MASS)
  s2n_indvec = c(rep(1,4),rep(2,4))
  lambda_indVec = rep(c(2,3,4,5),2)
  All = foreach(j=1:8) %dopar%{ 
    library(MASS)
    library(fields)
    s2n_ind=s2n_indvec[j]
    lambda_ind=lambda_indVec[j]
    SSE = array(dim=c(2,2,5,5))
  for(n_ind in 1:2){ #####Fill in, continue...  
    n = nvec[n_ind]
    s2n = s2nvec[s2n_ind]
    for(R in 1:5){
      set.seed(Seeds[i,n_ind,s2n_ind,R])
      Ye = array(rnorm(n*q1*q2),dim=(c(n,q1,q2)))
      X = array(rnorm(n*p1*p2),dim=c(n,p1,p2))
      ##give correlation of 0.6:
   #   COV <- stationary.image.cov(theta=1/log(1.6667),Covariance="Exponential",setup=TRUE,grid=list(x=1:p1,y=1:p2))
    #  for(t in 1:n) X[t,,] <- sim.rf(COV)
      L = length(dim(X))-1
      N=dim(X)[1]
      P = dim(X)[2:(L+1)]
      M = length(dim(Ye))-1
      Q = dim(Ye)[2:(M+1)]
      Xmat = array(X,dim=c(n,prod(P)))
      Y=Ye
        U = list()
        for(l in 1:L) U[[l]] = matrix(rnorm(P[l]*R),ncol=R)
        V = list()
        for(l in 1:M) V[[l]] = matrix(rnorm(Q[l]*R),ncol=R)
        Vmat.true = matrix(nrow=prod(Q),ncol=R)
        for(r in 1:R){
          Vr = lapply(V, function(x) x[,r])
          Vmat.true[,r] = as.vector(array(apply(expand.grid(Vr), 1, prod), dim=Q))
        }
        
        Bmat.true = matrix(nrow=R,ncol=prod(P))
        for(r in 1:R){
          Ur = lapply(U, function(x) x[,r])
          Br = array(apply(expand.grid(Ur), 1, prod), dim=P)  
          Bmat.true[r,] = array(Br,dim=c(1,prod(P)))
        }
        Ysig = as.vector(Xmat%*%t(Bmat.true)%*%t(Vmat.true))
        Ysig = array(as.vector(Ysig),dim=(c(n,q1,q2)))
        s2n.scale = s2n*sqrt(sum(Ye^2))/sqrt(sum(Ysig^2))
        Y = Ysig*s2n.scale+Ye
        Ymat = array(Y,dim=c(n,prod(Q)))
        lambda = lambdaVec[lambda_ind]
        Rest=R
      
        ##generate test data
        test = 500
        Xmat.new = array(rnorm(test*p1*p2),dim=c(test,p1*p2))
        if(R>0){
          Ysig.new = as.vector(Xmat.new%*%t(Bmat.true)%*%t(Vmat.true))
          Y.new = Ysig.new*s2n.scale+rnorm(test*q1*q2)}
        if(R==0){Y.new=rnorm(test*q1*q2)}
        Y.new.mat = array(Y.new,dim=c(test,prod(Q)))
        Ypred.mat = array(NA,dim=c(test,prod(Q)))
        ###Now estimate for each entry
        for(yind in 1:50){
        resList=list()
        resSSE = c()
        for(iter in 1:5){
          resList[[iter]] <- simple_rrr(X,Ymat[,yind],lambda,R=Rest,annealIter=100)
          resSSE[iter] = resList[[iter]]$sse[length(resList[[iter]]$sse)]
        }  
        res = resList[[which.min(resSSE)]]
        Ypred.mat[,yind] = as.vector(Xmat.new%*%t(res$Bmat)%*%rep(1,R))
       }
          SSE[n_ind,s2n_ind,lambda_ind,R] = sum((Ypred.mat-Y.new.mat)^2)/sum((Y.new.mat)^2)
        }} 
  list(SSE) 
}

save(All, file=paste("~/Revision Code/Revision2/IndepYRes/FullSimIndepY_V3",i,".rda"))
}


####Load results

##load 1 results

#load("~/Dropbox/ContinuumTensorRegression/Revision Code/Revision2/RidgeRes/FullSimRidge 1 .rda")

I = list()
for(k in 1:30){
  if(k==1){ load("~/Dropbox/ContinuumTensorRegression/Revision Code/Revision2/RidgeRes/FullSimRidge 1 .rda")} 
  if(k>1){
    load(paste("~/Dropbox/ContinuumTensorRegression/Revision Code/Revision2/RidgeRes/FullSimRidge",k,".rda"))
  }
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,4),rep(2,4))
  lambda_indVec = rep(c(2,3,4,5),2)
  for(j in 1:8){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:1){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:30){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/30


####Now only for correct ranks

rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])# ###error in the middle with regularization


####Now only for correct ranks
rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])


##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}

apply(means,c(1,2),sd)/sqrt(10)

AllSums = I[[1]][[4]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[4]]
}

AllCov = AllSums/10

rowMeans(AllCov[2,2,,]) ###error increasing with regularization
rowMeans(AllCov[2,1,,]) ###No substantive differences
rowMeans(AllCov[1, 1,,])##error decreasing with regularization
rowMeans(AllCov[1, 2,,])#

AllSums = I[[1]][[3]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[3]]
}

AllLength = AllSums/10

rowMeans(AllLength[2,2,,]) ###error increasing with regularization
rowMeans(AllLength[2,1,,]) ###No substantive differences
rowMeans(AllLength[1, 1,,])##error decreasing with regularization
rowMeans(AllLength[1, 2,,])#


