
source('rrr.R')

##run simulation for predictive performance with independent ridge regressions

library(doParallel)
library(foreach)
cl <- makeCluster(20)
registerDoParallel(cl)
q1 = 5
q2 = 10
p1 = 15
p2 = 20
nvec = c(30,120)
s2nvec = c(1,5)
lambdaVec = c(0,0.5,1,5,50)
Seeds = array(30*c(1:(10*2*2*5)),dim=c(30,2,2,5))

for(i in 1:10){
  s2n_indvec = c(rep(1,5),rep(2,5),rep(1,5),rep(2,5))
  lambda_indVec = rep(c(1,2,3,4,5),4)
  n_indvec = c(rep(1,10),rep(2,10))
  All = foreach(j=1:20) %dopar%{ 
    library(MASS)
    s2n_ind=s2n_indvec[j]
    lambda_ind=lambda_indVec[j]
    n_ind = n_indvec[j]
    SSE = array(dim=c(2,2,5,5,5))
    n = nvec[n_ind]
    s2n = s2nvec[s2n_ind]
    for(R in 1:5){
      set.seed(Seeds[i,n_ind,s2n_ind,R])
      Ye = array(rnorm(n*q1*q2),dim=(c(n,q1,q2)))
      X = array(rnorm(n*p1*p2),dim=c(n,p1,p2))

      L = length(dim(X))-1
      N=dim(X)[1]
      P = dim(X)[2:(L+1)]
      M = length(dim(Ye))-1
      Q = dim(Ye)[2:(M+1)]
      Xmat = array(X,dim=c(n,prod(P)))
      Y=Ye
        U = list()
        for(l in 1:L) U[[l]] = matrix(rnorm(P[l]*R),ncol=R)
        V = list()
        for(l in 1:M) V[[l]] = matrix(rnorm(Q[l]*R),ncol=R)
        Vmat.true = matrix(nrow=prod(Q),ncol=R)
        for(r in 1:R){
          Vr = lapply(V, function(x) x[,r])
          Vmat.true[,r] = as.vector(array(apply(expand.grid(Vr), 1, prod), dim=Q))
        }
        Bmat.true = matrix(nrow=R,ncol=prod(P))
        for(r in 1:R){
          Ur = lapply(U, function(x) x[,r])
          Br = array(apply(expand.grid(Ur), 1, prod), dim=P)  
          Bmat.true[r,] = array(Br,dim=c(1,prod(P)))
        }
        Ysig = as.vector(Xmat%*%t(Bmat.true)%*%t(Vmat.true))
        Ysig = array(as.vector(Ysig),dim=(c(n,q1,q2)))
        s2n.scale = s2n*sqrt(sum(Ye^2))/sqrt(sum(Ysig^2))
        Y = Ysig*s2n.scale+Ye
        Ymat = array(Y,dim=c(n,prod(Q)))
        lambda = lambdaVec[lambda_ind]
        if(N==30){folds <- list(c(1:6),c(7:12),c(13:18),c(19:24),c(25:30))}
        if(N==120){folds <- list(c(1:24),c(25:48),c(49:72),c(73:96),c(97:120))}
        for(Rest in 1:5){
        Ypred.mat = array(NA,dim=c(N,prod(Q)))
        ###Now estimate for each fold
        resList=list()
        resSSE = c()
        for(f in 1:5){
        print(Rest)
        print(f)
          for(iter in 1:5){
            resList[[iter]] <- rrr(X[-folds[[f]],,],Y[-folds[[f]],,],lambda,R=Rest,annealIter=100)
            resSSE[iter] = resList[[iter]]$sse[length(resList[[iter]]$sse)]
          }  
          res = resList[[which.min(resSSE)]]
          Vmat = matrix(nrow=prod(Q),ncol=Rest)
          for(r in 1:Rest){
            Vr = lapply(res$V, function(x) x[,r])
            Vmat[,r] = as.vector(array(apply(expand.grid(Vr), 1, prod), dim=Q))
          }
          Bmat = matrix(nrow=Rest,ncol=prod(P))
          for(r in 1:Rest){
            Ur = lapply(res$U, function(x) x[,r])
            Br = array(apply(expand.grid(Ur), 1, prod), dim=P)  
            Bmat[r,] = array(Br,dim=c(1,prod(P)))
          }
          Ypred.mat[folds[[f]],] = Xmat[folds[[f]],]%*%t(Bmat)%*%t(Vmat)
        }
          SSE[n_ind,s2n_ind,lambda_ind,R,Rest] = sum((Ypred.mat-Ymat)^2)/sum((Ymat)^2)
        }} 
  list(SSE) 
}

  save(All, file=paste("FullSimCV",i,".rda"))
}





