
simple_rrr <- function(X,Y,lambda=0,annealIter=0,R=1,convThresh=10^(-5), seed=0){
  if(seed>0) set.seed(seed)
  lambdaFin = lambda
  L = length(dim(X))-1
  N=dim(X)[1]
  P = dim(X)[2:(L+1)]
  Xmat = array(X,dim=c(N,prod(P)))
  Y = as.vector(Y)
  Yvec = as.vector(Y)
  
  U = list()
  for(l in 1:L) U[[l]] = matrix(rnorm(P[l]*R),ncol=R)
  
  Bmat = matrix(nrow=R,ncol=prod(P))
  for(r in 1:R){
    Ur = lapply(U, function(x) x[,r])
    Br = array(apply(expand.grid(Ur), 1, prod), dim=P)  
    Bmat[r,] = array(Br,dim=c(1,prod(P)))
  }
  Y_pred = as.vector(Xmat%*%t(Bmat))
  Xarrays = list()
  for(l in 1:L){
    Xarrays[[l]] <- array(dim=c(N,P[l],prod(P[-l])))
    perm = c(l,c(1:L)[-l])
    for(i in 1:N){
      X_slice = array(Xmat[i,],dim=c(P))
      X_slice_perm = aperm(X_slice,perm)
      Xarrays[[l]][i,,] = array(X_slice_perm,dim=c(P[l],prod(P[-l])))
    }
  }  

  sse=c()
  sseSig = c()
  sseR = c()
  j=0
  conv=convThresh+1
  Vmat <- t(rep(1,R))
  while(conv>convThresh){
    j=j+1
    if(j<=annealIter){
      lambda = 100*(annealIter-j)/annealIter+lambdaFin
    }
    for(l in 1:L){
      ###Matrix B
      B_red = matrix(nrow=prod(P[-l]),ncol=R)
      for(r in 1:R){
        Ured_r <- lapply(U[-l], function(x) x[,r]) 
        B_red[,r] = as.vector(array(apply(expand.grid(Ured_r), 1, prod), dim=P[-l])) 
      }
      X_red = matrix(nrow=N,ncol=P[l]*r)
      perm = c(l,c(1:L)[-l])
      for(i in 1:N){X_red[i,] = as.vector(Xarrays[[l]][i,,] %*% B_red)} 
      C = matrix(nrow=dim(X_red)[1],ncol=dim(X_red)[2])
      for(r in 1:R){
        index = ((r-1)*P[l]+1):(r*P[l])
        C[,index] =X_red[,index]
      }
      lambdaMat = kronecker(t(Vmat)%*%Vmat*t(B_red)%*%B_red,lambda*diag(P[l]))
      CP <- crossprod(X_red)*kronecker(t(Vmat)%*%Vmat, matrix(rep(1,P[l]^2),nrow=P[l]))
      regMat = solve(CP+lambdaMat) 
      Ulvec <- regMat%*%(t(C)%*%Yvec)
      U[[l]] = matrix(Ulvec,nrow=P[l])
      Bmat = matrix(nrow=R,ncol=prod(P))
      for(r in 1:R){
        Ur = lapply(U, function(x) x[,r])
        Br = array(apply(expand.grid(Ur), 1, prod), dim=P)  
        Bmat[r,] = array(Br,dim=c(1,prod(P)))
      }
      Y_pred = as.vector(Xmat%*%t(Bmat)%*%t(Vmat))
      sse[(L)*(j-1)+l] = sum((Yvec-Y_pred)^2)
      sseR[(L)*(j-1)+l] = sum((Yvec-Y_pred)^2)+lambda*sum((t(Bmat))^2)
    }
  if(j>1) conv = abs(sseR[length(sseR)]-sseR[length(sseR)-L])/sseR[length(sseR)] 
  }
  return(list(Bmat=Bmat,U=U,sse=sse,sseR=sseR))
}



